
export function crudLocalstorageApi (action, options) {
  // determine the operation
  const [ name, actionType ] = action.type.split('/')
  switch (actionType) {
    case 'READ_REQUEST':
      return new Promise((resolve, reject) => {
        const items = localStorage.getItem(name) || []
        resolve(items[action.id])
      })
    case 'CREATE_REQUEST':
      return new Promise((resolve, reject) => {
        try {
          const items = localStorage.getItem(name) || {}
          items[action.id] = action.data
          console.log(items)
          localStorage.setItem(name, items)
          resolve(null)
        } catch (error) {
          reject(error)
        }
      })
    case 'UPDATE_REQUEST':
      return new Promise((resolve, reject) => {
        try {
          const items = localStorage.getItem(name) || {}
          items[action.id] = action.data
          localStorage.setItem(name, items)
          resolve(null)
        } catch (error) {
          reject(error)
        }
      })
    case 'DELETE_REQUEST':
      return new Promise((resolve, reject) => {
        try {
          const items = localStorage.getItem(name) || {}
          delete items[action.id]
          localStorage.setItem(name, items)
          resolve(null)
        } catch (error) {
          reject(error)
        }
      })
  }
}
