import React from 'react'

class EditSetting extends React.Component {
  constructor () {
    super()
    this.saveSetting = this.saveSetting.bind(this)
    this.updateSetting = this.updateSetting.bind(this)
  }

  saveSetting (event) {
    event.preventDefault()
    this.props.actions.updateSetting(12, {
      name: this.name.value,
      description: this.description.value,
      nrOfBits: this.nrOfBits.value,
      comment: this.comment.value,
      format: this.format.value,
      formatOverride: this.formatOverride.value
    })
    console.log('Saving ')
  }

  updateSetting (event) {
    event.preventDefault()
    this.props.actions.updateSetting(this.id.value, {
      name: this.name.value,
      description: this.description.value,
      nrOfBits: this.nrOfBits.value,
      comment: this.comment.value,
      format: this.format.value,
      formatOverride: this.formatOverride.value
    })
    console.log('Updating')
  }

  checkSetting (event) {

  }

  render () {
    const { setting } = this.props
    if (typeof setting.id === 'undefined') {
      setting.id = null
      setting.name = ''
      setting.description = ''
      setting.nrOfBits = 1
      setting.range = {
        lower: 0,
        upper: 1
      }
      setting.comment = ''
      setting.format = ''
      setting.formatOverride = {}
    }
    return (
      <form className='app-form' onSubmit={this.saveSetting}>
        <input type='text' ref={input => { this.name = input }} value={setting.name} placeholder='Setting name' onChange={this.updateSetting} onBlur={this.checkSetting} />
        <input type='text' ref={input => { this.description = input }} value={setting.description} placeholder='Description' onChange={this.updateSetting} onBlur={this.checkSetting} />
        <input type='text' ref={input => { this.id = input }} value={setting.id} placeholder='Description' onChange={this.updateSetting} onBlur={this.checkSetting} />
        <input type='text' ref={input => { this.nrOfBits = input }} value={setting.nrOfBits} placeholder='Number of bits' onChange={this.updateSetting} onBlur={this.checkSetting} />
        <input type='text' ref={input => { this.comment = input }} value={setting.comment} placeholder='Comment' onChange={this.updateSetting} onBlur={this.checkSetting} />
        <input type='text' ref={input => { this.format = input }} value={setting.format} placeholder='Format' onChange={this.updateSetting} onBlur={this.checkSetting} />
        <input type='text' ref={input => { this.formatOverride = input }} value={setting.formatOverride} placeholder='Format Override' onChange={this.updateSetting} onBlur={this.checkSetting} />
        <button type='submit'>Save</button>
      </form>
    )
  }
}

export default EditSetting
